/* .----------------------------------------------------------------------.
  /  C<<1 header file - C language style sheet - GNU C/ANSI C99 compliant 
 /  Cumbersome Extraction and Report Language - http://cll1h.arachne.cz/ 
'---------------------------------------------------------------------- */
/*
   Copyright (c) 2004-2008 Michael xChaos Polak - x(at)n.cz

   The C<<1 header file is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The C<<1 header file is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with C<<1 header file; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

*/
#ifndef _CLL1_H
#define _CLL1_H
#define CLL1H_VERSION "0.7.1"
/* .----------------------------------------------------------------------.
  /  0. Library definitions not parsed by @CC, updated 2008-01-26 xCh.
 '---------------------------------------------------------------------- */
/*
@define USE_LIBRARY_MYSQL -lmysqlclient
@define USE_LIBRARY_FASTCGI -lfcgi
@define USE_PREPROCESSOR cake *.html *.xml > _include.c
@define USE_POSTPROCESSOR strip @
*/
/* .----------------------------------------------------------------------.
  /  1. C<<1 header auto include, updated 2008-01-26 xCh.
 '---------------------------------------------------------------------- */
#ifndef DISABLE_LIBRARY_LIBC
#include <string.h>
#include <malloc.h>
#include <time.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#ifdef USE_LIBRARY_FASTCGI
#include <fcgi_stdio.h>
#else
#include <stdio.h>
#endif
#endif
#ifdef USE_LIBRARY_MYSQL
#include <mysql/mysql.h>
#endif
/* .----------------------------------------------------------------------.
  /  2. C<<1 then buddhist section, updated 2008-01-26 xCh.
 '----------------------------------------------------------------------- */
#ifndef DISABLE_MODULE_THEN_BUDDHISM 
#define then
#define boolean int
#define MAYBE (int)((RANDOM_SEED?random():(srandom(RANDOM_SEED=time(NULL)),random()))%2)
#define WHOKNOWS (int)(srandom(time(NULL)),random()%2)
#define create_var(ID,TYPE,INIT) TYPE ID=INIT
#define define_var(ID,TYPE) TYPE ID
#endif
/* .----------------------------------------------------------------------.
  /  3. C<<1 almost then buddhist section, updated 2008-01-26 xCh.
 '----------------------------------------------------------------------- */
#define not !
#define and &&
#define or ||
#define TRUE 1
#define FALSE 0
#define coalesce(VAR,NOTNULLNORFALSE) (VAR?VAR:(NOTNULLNORFALSE))
#define bool_str(VALUE) ((VALUE)?"TRUE":"FALSE")
#define _CLL1_GLOBALS char *NIL="NULL", *EOL="\n", *OFS=" ", *IFS=" \t\n"; time_t RANDOM_SEED=0;
/* .----------------------------------------------------------------------.
  /  4. C<<1 data declaration and allocation, updated 2008-01-07 xCh.
 '----------------------------------------------------------------------- */
#define mem struct
#define uses_mem(TYPE) struct *TYPE this
#define create_mem(ID,...) struct _ARG1(__VA_ARGS__,) *ID=get_mem(__VA_ARGS__)
#define new_mem(ID,...) struct _ARG1(__VA_ARGS__,) *ID=init_mem(__VA_ARGS__)
#define define_mem(ID,TYPE) struct TYPE *ID=NULL
#define define_mems(ID1,ID2,TYPE) define_mem(ID1,TYPE); define_mem(ID2,TYPE)
#define get_mem(...) (struct _ARG1(__VA_ARGS__,)*)_cll1_malloc(sizeof(struct _ARG1(__VA_ARGS__,)), _ARG2(__VA_ARGS__,,) - 0 )
#define init_mem(...)  _mem_##TYPE##_( _ARG2(__VA_ARGS__,,) - 0 )
#define construct_mem(TYPE) (struct TYPE *) _mem_##TYPE##_(void) {   }
#define create_list(ID1,I2,TYPE) create_mem(ID1,TYPE); struct TYPE *ID2=((ID1->__next=NULL),ID1)
#define create_str(ID,INIT) char *ID=INIT
#define define_str(ID) char *ID=NULL
#define get_str(...) (char *)_cll1_get_str(__VA_ARGS__,NIL)
#define create_context(ID) create_mem(ID,_CTXAtom)
#define define_context(ID) define_mem(ID,_CTXAtom)
#define list(TYPE) struct TYPE *__next
#define tree(TYPE) struct TYPE *__next; struct TYPE *__seek
#define dictionary(TYPE) tree(TYPE); char *__key
#define array(TYPE) tree(TYPE); int __key
#define interface(TYPE) struct TYPE *__interface
/* .----------------------------------------------------------------------.
  /  5. C<<1 string manipulation, updated 2008-01-26 xCh.
 '----------------------------------------------------------------------- */
#define eq(A,B) !strcmp(A,B)
#define eqi(A,B) !strcasecmp(A,B)
#define print(...) _cll1_print(__VA_ARGS__,NIL)
#define fprint(...) _cll1_fprint(__VA_ARGS__,NIL)
#define file_print(...) _cll1_fprint(_F,__VA_ARGS__,NIL)
#define echo(...) _cll1_echo(__VA_ARGS__,NIL)
#define fecho(...) _cll1_fecho(__VA_ARGS__,NIL)
#define file_echo(...) _cll1_fecho(_F,__VA_ARGS__,NIL)
#define suffix(A,B,C) (((A=strrchr(B,C))&&!(*(A++)=0))||(A=B))
#define prefix(A,B,C) ((A=B),((B=strchr(B,C))&&!(*(B++)=0)||(B=A)))
#define tr(STR,B,C) {char *_S=STR; /***/ while(S && *_S) {if(*_S==B)*_S=C; _S++;} }
/* .----------------------------------------------------------------------.
  /  6. C<<1 data container manipulation, updated 2008-01-26 xCh.
 '----------------------------------------------------------------------- */
#define push(NODE,HEAD) ( NODE ? ((NODE->__next=HEAD),(HEAD=NODE)) : NULL )
#define pop(NODE,HEAD) ( HEAD ? ((NODE=HEAD->__next),free(HEAD),(HEAD=NODE)) : (NODE=NULL) )
#define append(NODE,HEAD) { void *N=NODE; /* <-' */ NODE->__next=NULL; for_search(NODE,HEAD,!NODE->__next) { NODE->__next=N; break; } }
#define remove(NODE,HEAD,EXPR) { void **_D=NULL; /* <-' */ for_search(NODE,HEAD,EXPR) { if(_D)*_D=NODE->__next; else HEAD=NODE->__next; free(NODE); } else _D=(void *)&(NODE->__next); }
#define drop(NODE,HEAD) for( NODE=HEAD; NODE || (HEAD=NULL); HEAD=NODE, NODE=NODE->__next, free(HEAD) )
//to do: seek
//to do: store
#define order_by(K1,K2) (K1>K2)
#define desc_order_by(K1,K2) (K1<K2)
#define sort_by(K1,K2) (strcasecmp(K1, K2)>0)
#define desc_sort_by(K1,K2) (strcasecmp(K1, K2)<0)
#define ascii_by(K1,K2) (strcmp(K1, K2)>0)
#define desc_ascii_by(K1,K2) (strcmp(K1, K2)<0)
#define insert(NODE,HEAD,EXP,K) { if(HEAD) { void **_L=NULL, *H=HEAD; /* <-' */ for_search(HEAD,H,EXP(HEAD->K,NODE->K)) { if(_L) {*_L=NODE; NODE->__next=HEAD; } else push(NODE,H); break; } else _L=(void *)&(HEAD->__next); if(!HEAD)*_L=NODE; HEAD=H; } else if (NODE) { push(NODE,HEAD); HEAD->__next=NULL; } }
#define sort(NODE,HEAD,EXP,K) { void *_NEXT; /* <-' */ NODE=HEAD; HEAD=NULL; do { _NEXT=NODE->__next; NODE->__next=NULL; insert(NODE,HEAD,EXP,K); NODE=_NEXT; } while(_NEXT); }
/* .----------------------------------------------------------------------.
  /  7. C<<1 builtin iterators and conditionals, updated 2008-01-26 xCh.
 '----------------------------------------------------------------------- */
#define loop while(TRUE)
#define repeat(N) if(N>0) _NEW(I,0) while(_I++<N)
#define for_range(VAR,FROM,TO) for( VAR=FROM ; FROM<=TO?VAR<=TO:VAR>=TO ; FROM<=TO?VAR++:VAR--)
#define for_each(NODE,HEAD) for(NODE=HEAD; NODE; NODE=NODE->__next)
#define for_search(NODE,HEAD,EXPR) for_each(NODE,HEAD) if(EXPR)
#define for_file_lines(STR,FNAME) /* _NEW(CTX,get_context()) file_read(FNAME) for(use_context(_CTX),STR=file_line(_F);release_context(_M),(*S && !feof(_F));STR=file_line(_F),end_context()) _CATCH */
#define for_input_lines(S,L) /* _NEW(CTX,get_context()) for(use_context(_CTX),STR=file_get_line(stdin);release_context(_M),(*S && !feof(stdin));STR=file_get_line(stdin)) _CATCH */
#define for_ints(VAR,...) _NEW(I,0) while((VAR=_cll1_for_ints(_I++,__VA_ARGS__,-1))>=0)
#define for_strs(VAR,...) _NEW(I,0) while((VAR=(char *)_cll1_for_ptrs(_I++,__VA_ARGS__,NIL))!=NIL)
#define for_args _NEW(I,1) while(_I++<argc)
#define this_arg argv[_I]
#define next_arg ((_I+1<argc)?argv[_I]:NULL)
#define skip_next _I++
#define if_exists(A,B,C) for_search(A,B,C) break; if(A)
#define if_args if(argc>1)
#define switch_for_args  for_args switch_str(this_arg)
#define switch_str(STR) _NEW(S,STR)
#define if_case(VAL) if(eq(argv[_I],VAL))
#define for_fields(FIELD,STR) for_valid_split(FIELD,STR,OFS)
#define for_split_str(A,B,C) for(prefix(A,B,C);A;(A!=B)&&prefix(A,B,C)||(A=NULL))
#define for_valid_split(A,B,C) for_split_str(A,B,C) if(*A)
#define switch_for_columns(A,B,C) _FOR_COLUMNS(A,B,C) switch(__I)
#define switch_for_valid_columns(A,B,C) _FOR_VALID_COLUMNS(A,B,C) switch (_I)
#define if_column_number(A,B,C,V) _FOR_COLUMNS(A,B,C) if(_I==V)
#define if_valid_column_number(A,B,C,V) _FOR_VALID_COLUMNS(A,B,C) if(_I==V)
/* .----------------------------------------------------------------------.
  /  8. C<<1 object oriented infrastructure, updated 2008-01-26
 '----------------------------------------------------------------------- */
#define method_args void *_self, void  *_method
#define I_am(TYPE) struct TYPE *self=(struct TYPE *)_self
#define define_metaobject(METATYPE,ITYPE) struct METATYPE { struct ITYPE *__interface; };
#define define_interface(MTYPE,ITYPE) struct ITYPE *_interface_##MTYPE##ITYPE(void *dummy, ...) { define_mem(_FACE,IFACE); va_list(ap); _FACE=get_mem(IFACE) _bind_##MTYPE##ITYPE(_FACE); return _FACE; } void _bind_##MTYPE##ITYPE(struct IFACE *_FACE)
#define bind_method(METHOD,FUNCTION) _FACE->METHOD=FUNCTION
#define construct_interface(MTYPE,...) _interface_##MTYPE##_ARG1(__VA_ARGS__)((void *)__get_##MTYPE##__VA_ARGS__)
#define init_object(TYPE,...) _object_##TYPE##_(__VA_ARGS__)
#define construct_object(TYPE,...) (struct TYPE *)_object_##TYPE##_
#define _(OBJECT,...) (  _ASSERT(OBJECT), (*( OBJECT->interface->_ARG1(__VA_ARGS__,) )) ( OBJECT,OBJECT->interface->__VA_ARGS__ )  )
#define __(OBJECT,...) (  _ASSERT(OBJECT), (*( __cll1_seekmethod(OBJECT->interface,_ARG1(__VA_ARGS__,)) )) ( OBJECT,OBJECT->interface->__VA_ARGS__ )  )
#define call(OBJTYPE,METHOD,...) { int _N=0; struct OBJTYPE *_OBJ; /* <-' */ while( (_OBJ=(struct OBJTYPE *)_cll1_for_ptrs(_N++,__VA_ARGS__,NIL))!=(struct OBJTYPE *)NIL ) _(_OBJ,METHOD); }
/* .----------------------------------------------------------------------.
  /  9. implementation of C<<1 library functions, updated 2008-01-26 xCh.
 '----------------------------------------------------------------------- */
#define _MALLOC void *_cll1_malloc(size_t size,...) { /*temporary solution*/ return malloc(size); }
#define _CLL1_FPRINT(IOSTREAM) { int ofs=0; va_list ap; /* <-' */ for(va_start(ap,s);s!=NIL;s=va_arg(ap,char *)) { if(ofs)fputs(OFS,IOSTREAM);else ofs=1;/**/fputs(coalesce(s,NIL),IOSTREAM); } va_end(ap); fputs(EOL,IOSTREAM); }
#define _PRINT void _cll1_print(char *s,...) _CLL1_FPRINT(stdout)
#define _FPRINT void _cll1_fprint(FILE *f,char *s,...) _CLL1_FPRINT(f)
#define _CLL1_FECHO(IOSTREAM) { va_list ap; /* <-' */ for(va_start(ap,s);s!=NIL;s=va_arg(ap,char *)) fputs(coalesce(s,NIL),IOSTREAM); va_end(ap); }
#define _ECHO void _cll1_echo(char *s,...) _CLL1_FECHO(stdout)
#define _FECHO void _cll1_fecho(FILE *f,char *s,...) _CLL1_FECHO(f)
#define _FOR_INTS int _cll1_for_ints(int i, int n, ...) { int j=0;va_list ap; /* <-' */ va_start(ap,n); while(n>=0 && j++<i) n=va_arg(ap,int); return n; }
#define _FOR_PTRS void *_cll1_for_ptrs(int i, void *v, ...) { int j=0;va_list ap; /* <-' */ va_start(ap,v); while(v!=(void *)NIL && j++<i) v=va_arg(ap,void *); return v; }
/* .----------------------------------------------------------------------.
  /  10. C<<1 globals and private macros, updated 2008-01-27 by xCh.
 '----------------------------------------------------------------------- */
#define _ARG1(ARG1,...) ARG1
#define _ARG2(ARG1,ARG2,...) ARG2
#define _ANYSTACK(TYPE,NAME) struct _##NAME##Atom { TYPE NAME; int C; list(_##NAME##Atom); } *_##NAME##atom,*_##NAME##stack=NULL;
//#define _ISTACK struct _IAtom { int i; int C; list(_IAtom); } *_Iatom,*_Istack=NULL;
//#define _SSTACK struct _SAtom { char *s; int C; list(_SAtom); } *_Satom,*_Sstack=NULL;
//#define _FSTACK struct _FAtom { FILE *F; int C; list(_FAtom); } *_Fatom,*_Fstack=NULL;
//#define _MSTACK struct _MAtom { void *ptr; size_t size; int C; tree(_MAtom); } *_Matom,*_Mstack=NULL;
#define _CLL1_STACKS _ANYSTACK(int,I) _ANYSTACK(char *,S) _ANYSTACK(FILE *,F) _ANYSTACK(void *,CTX)
//#define _NEW_(ATOM,STACK,TYPE) (ATOM=get_mem(TYPE),ATOM->C=1,push(ATOM,STACK);ATOM->C||(pop(ATOM,STACK),0);ATOM->C--)
#define _NEW(NAME,VALUE) for(_##NAME##atom=get_mem(_##NAME##Atom),_##NAME##atom->NAME=(VALUE),_##NAME##atom->C=1,push(_##NAME##atom,_##NAME##stack);_##NAME##atom->C||(pop(_##NAME##atom,_##NAME##stack),0);_##NAME##atom->C--)
//#define _NEW_I for _NEW_(_Iatom,_Istack,_IAtom)
//#define _NEW_S for _NEW_(_Satom,_Sstack,_SAtom)
//#define _NEW_F for _NEW_(_Fatom,_Fstack,_FAtom)
#define _I (_Iatom->I)
#define _S (_Satom->S)
#define _F (_Satom->F)
#define _CTX (_CTXatom->CTX)
#define _FOR_COLUMNS(A,B,C) _NEW(I,0) for( prefix(A,B,C) ; A ; ((A!=B)&&prefix(A,B,C)||(A=NULL) ),_I++ ) 
#define _FOR_VALID_COLUMNS(A,B,C) _NEW(I,0) for( prefix(A,B,C) ; A ; ((A!=B)&&prefix(A,B,C))||(A=NULL) ) if(*A&&++_I) 
/* .----------------------------------------------------------------------.
  /  11. C<<1 CGI and FASTCGI handling, updated 2008-01-16 by xCh.
 '----------------------------------------------------------------------- */
#ifdef USE_LIBRARY_FASTCGI
#define while_fastcgi_accept while(FCGI_Accept()>=0)
#define USE_MODULE_CGI
#endif
#ifdef USE_MODULE_CGI
#define cgi(MIME) { char *PTR; /* <-' */ recycle_context(_CGI); _CGIdict=NULL; for_split_str(PTR,getenv("QUERY_STRING"),'&')   /* _init_cgi */ if(MIME) printf("Content-type: %s\r\n\r\n",MIME); }
//todo #define _GETCGI char *getcgi(VAR) {     }
#define _CGI_GLOBALS define_context(_CGI); struct _CGIVariable { char *V; dictionary(_CGIVariable); } *_CGIvariable,*_CGIdict;
#else
#define _CGI_GLOBALS
#endif
/* .----------------------------------------------------------------------.
  /  12. MySQL wrappers + SQL object interface, updated 2007-12-19 by xCh.
 '----------------------------------------------------------------------- */
#ifdef USE_LIBRARY_MYSQL
#define define_sql(CONN) MYSQL *CONN
#define create_sql(CONN) MYSQL *ID=mysql_init(NULL)
#define sql_connect(CONN,S,U,P,D) mysql_real_connect(CONN,S,U,P,D,0,NULL,0)
//todo sql_query
//todo sql_queryf
//todo for_sql_query_results(ROW,CONN,QUERY)
//todo for_sql_queryf_results
#define if_db_connect(U,P,D) _NEW(SQLC,mysql_init(NULL)) for(;_SQLC && mysql_real_connect(_SQLC,"localhost",U,P,D,0,NULL,0);mysql_close(SQLC),SQLC=NULL)
#define for_db_query_results(ROW,QUERY) _NEW(MYSQLR,mysql_query(_MYSQLC,QUERY)) for( (_SQLR=(_MYSQLR?0:mysql_use_result(_MYSQLC))),(ROW=(_MYSQLR?mysql_fetch_row(_MYSQLR):NULL)) ; ROW ; ROW=mysql_fetch_row(_MYSQLR) )
//todo db_query
//todo for_db_results
//todo for_db_queryf_results(ROW,...)
//todo db_queryf
#define _MYSQLC (_MYSQLCatom->MYSQLC)
#define _MYSQLR (_MYSQLRatom->MYSQLR)
#define _SQL_GLOBALS _ANYSTACK(MYSQL,MYSQLC) _ANYSTACK(MYSQL_RES,MYSQLR)
#else
#define _SQL_GLOBALS
#endif
//#ifdef USE_INTERFACE_SQL
//todo #define _SQL_OBJECT mem Sql { interface(SqlInterface); char *hostname; char *username; char *password; char *database; }
//todo #define _SQL_CONSTRUCT define_construct(Sql) { self->hostname="localhost"; }
//#endif
/* ------------------------------------------------------------------- */
/* old - from version 0.6                                              */
/* =================================================================== */
/*
obsolete
#define strlwr(A) {char *_S=A; while(_&&*_S){*_S=tolower(*_S);_S++;}}
#define strupr(A) {char *_S=A; while(_&&*_S){*_S=toupper(*_S);_S++;}}
#define string(S,L) (S=(char *)malloc(L),*S=0)
#define duplicate(A,B) if(A) { string(B,strlen(A)+1); strcpy(B,A); }
#define concatenate(A,B,C) if (A && B) { string(C,strlen(A)+strlen(B)+1); strcpy(C,A); strcat(C,B); }
#define gotoalpha(CHAR) if(CHAR)while(*CHAR && !isalpha(*CHAR))CHAR++
#define goto_alpha(CHAR) if(CHAR)while(*CHAR && !isalpha(*CHAR) && *CHAR!='_')CHAR++
#define gotoalnum(CHAR) if(CHAR)while(*CHAR && !isalnum(*CHAR))CHAR++
#define goto_alnum(CHAR) if(CHAR)while(*CHAR && !isalnum(*CHAR) && *CHAR!='_')CHAR++
#define skipalpha(CHAR) if(CHAR)while(*CHAR && isalpha(*CHAR))CHAR++
#define skip_alpha(CHAR) if(CHAR)while(*CHAR && (isalpha(*CHAR) || *CHAR=='_'))CHAR++
#define skipalnum(CHAR) if(CHAR)while(*CHAR && isalnum(*CHAR))CHAR++
#define skip_alnum(CHAR) if(CHAR)while(*CHAR && (isalnum(*CHAR) || *CHAR=='_'))CHAR++
#define skipspaces(CHAR) if(CHAR)while(*CHAR==' ')CHAR++
#define cutspaces(CHAR) if(CHAR){int _L=strlen(CHAR); while(--_L>0 && CHAR[_L]==' ')CHAR[_L]=0;}
#define gotochr(CHAR,C) if(CHAR)while(*CHAR && *CHAR!=C)CHAR++
#define strswitch(CHAR) {char *_K=CHAR; FILE *_F=NULL; {{ 
#define stroption(STR) if(eq(STR,_K))
#define match(KEY,VAL) {char *_K=KEY, *_V=VAL; FILE *_F=NULL; {{ 
#define assign(STR,SETVAR) stroption(STR) SETVAR=_V
*/
/* I/O iterations, updated 2004-04-19 by xCh. */

//#define fparse(S,L,F) for(fgets(S,L,F);*S && !feof(F);fgets(S,L,F))
//#define input(S,L) fparse(S,L,stdin)
//#define fstring(S,F) { int _C=0,_L=0; fpos_t _P; fgetpos(F,&_P); while(_C!='\n' && !feof(F)){ _C=fgetc(F); _L++; } string(S,_L); fsetpos(F,&_P);fgets(S,_L,F);fgetc(F);}
//#define parses(S,F) {FILE *_F=fopen(F,"r"); if(_F) { while(!feof(_F)) { fstring(S,_F);  
//obsolete
//#define parse(F) {char *_; FILE *_F=fopen(F,"r"); if(_F) { while(!feof(_F)) { fstring(_,_F);  
//#define fail }} else {{
//#define done }} if(_F)fclose(_F);}
//to do #define option(STR,SETVAR) if(_){char *_K,*_V,*_O,*_Q; duplicate(_,_Q); _O=_Q; tr(_O,'\t',' '); prefix(_K,_O,' '); if(eq(STR,_K)) {skipspaces(_O); prefix(_V,_O,'#'); cutspaces(_V); SETVAR=_V; _=NULL;} else free(_Q);}
//to do #define ioption(STR,SETVAR) if(_){char *_K,*_V,*_O,*_Q; duplicate(_,_Q); _O=_Q; tr(_O,'\t',' '); prefix(_K,_O,' '); if(eq(STR,_K)) {skipspaces(_O); prefix(_V,_O,'#'); cutspaces(_V); SETVAR=atoi(_V); _=NULL;} free(_Q);}
//to do #define loption(STR,SETVAR) if(_){char *_K,*_V,*_O,*_Q; duplicate(_,_Q); _O=_Q; tr(_O,'\t',' '); prefix(_K,_O,' '); if(eq(STR,_K)) {skipspaces(_O); prefix(_V,_O,'#');  cutspaces(_V); SETVAR=atol(_V); _=NULL;} free(_Q);}

/* I/O sequences, updated 2003-05-29 by xCh. */

#define nullreopen(F) F=freopen("/dev/null","r",F)
#define stdinredir(CMD) {int _r[2];pipe(_r);if(fork()==0){dup2(_r[1],1);close(_r[0]);CMD;exit(0);}nullreopen(stdin);dup2(_r[0],0);close(_r[1]);}
#define shell(CMD) stdinredir(system(CMD))
#define paste(STR) stdinredir(fputs(STR,stdout))

/* Useful structures, updated 2003-05-29 by xCh. */

//#define date(S) { time_t _T; _T=time(NULL); duplicate(ctime(&_T),S); }
/* ------------------------------------------------------------------- */
/* some general ideas, unfinished */
//bind_exception, unbind_exception 
//#define _CLL1_THROW(ERR)
//#define _CLL1_TRY _NEW_E for(bind_exception(0,NULL);;) if () {.... if(_Eatom->SYS) { if(_Eatom->RET) return; else break;} else { }
//#define _ASSERT(EXPR) assert(EXPR)
/* =================================================================== */

/* .----------------------------------------------------------------------.
  /  99. We have have done our homework - now let's have some fun:          
 '----------------------------------------------------------------------- */
#define _DEF_VARIABLES _CLL1_GLOBALS _CLL1_STACKS _SQL_GLOBALS _CGI_GLOBALS
#define _DEF_FUNCTIONS _MALLOC _ECHO _PRINT _FECHO _FPRINT _FOR_INTS _FOR_PTRS //_GET_STR _GET_MEM
#define _DEF_INTERFACE //_SQL_IFC _CAKE_IFC _STD_IFC _X_IFC
#define implement_cll1_library _DEF_VARIABLES _DEF_FUNCTIONS _DEF_INTERFACE
#ifdef USE_PREPROCESSOR
#include "_include.c"
#endif
#define program implement_cll1_library int main(int argc, char **argv)
/* #ifndef _CLL1_H */
#endif
